/***********************************************************/
/* Name: empf.c                                           */
/*                                                         */
/* Ein Gemeinschaftsprojekt der Epilepsy-Teams             */
/*                                                         */
/*                                                         */
/* written by Wolfgang Wierczeyko, Liebenburg              */
/*                                                         */
/*                                                         */
/* Prozessor:: ATmega644 @ 24 MHz	                       */
/*                                                         */
/*                                                         */
/***********************************************************/

#include "main.h"





/************************************************************************/
/* Auswerung des RC-Signals */
SIGNAL(SIG_INPUT_CAPTURE1)
{
	static signed int	start_wert, end_wert, N_EMPF_WERT;

	static unsigned int flanke = 0;

	
	
	if(flanke ==0)							/* Trigger auf Start Steigende Flanke */
	{
		start_wert = (unsigned int) ICR1; 	/* Startwert des Timers holen */
		TCCR1B 	&= ~(1 << ICES1);			/* Setze trigger auf fallende Flanke */
		flanke = 1;							/* Trigger auf negative Flanke */
											/* Testausgabe auf Oskar */
	}
	else
	{
		end_wert = (unsigned int) ICR1;		/* Timerendwert holen */
		TCCR1B 	|= (1 << ICES1);			/* Setze Trigger auf steigende Flanke */
		N_EMPF_WERT = end_wert - start_wert;	/* Wert im msec berechnen */
		flanke = 0;

											/* Testausgabe auf Oskar */

/* Hier noch einen Test einbauen ob Signal gut ist */

		N_EMPF_WERT = N_EMPF_WERT - 2150;				/* An ATMEGA162 mit 16MHz anpassen */
		N_EMPF_WERT = N_EMPF_WERT / (unsigned int) 300;


		if(N_EMPF_WERT < 0) N_EMPF_WERT = 0;	/* Nomieren der Werte */
		if(N_EMPF_WERT > 6) N_EMPF_WERT = 6;



		if((N_EMPF_WERT != EMPF_WERT) &&( N_EMPF_WERT < 6))
		{
			
			EMPF_WERT 			= N_EMPF_WERT;	
			EMPF_WERT_AENDERUNG = 1;			/* Empfangswert hat sich gendert */
//uart_send_int_0(N_EMPF_WERT);
		}

	}

}
