/****************************************************************/
/*	 OSD und HUD				                 				*/
/*	 															*/
/*																*/
/*																*/
/*																*/
/*	written by Wolfgang Wierczeyko	Mrz 2008					*/
/*																*/
/* Programm Geschichte											*/
/*																*/
/*	04.04.2008	Version 0.2										*/
/*				berarbeitet fr Platinen Ver. 0.1 und 0.2		*/
/*				Einbeziehung des Signal der Fernsteuerung		*/
/*	17.04.08	Version 0.4										*/
/*  			Vario funktion hinzugefgt						*/
/*																*/
/****************************************************************/


#include "main.h"


volatile uint8_t		MSEC1000	=0;
volatile uint8_t		MSEC500		=0;
volatile uint8_t		MSEC100		=0;
volatile uint8_t		MSEC10		=0;
volatile uint8_t		Tackt		=0;

volatile unsigned char 	RX_BUFF_0[RXB_LEN_0];
volatile unsigned char 	rx_poi_0;
volatile unsigned char 	ds_komplett_0;

volatile unsigned char 	r_on 		= 0;		/* Statusvariable fr die Leds */
volatile unsigned char 	r_blink 	= 1;
volatile unsigned char 	g_on 		= 0;
volatile unsigned char 	g_blink 	= 0;
volatile int 			old_volt 	= 0;	/* Alte Spannung Lipo			*/
volatile int			F_MIN 		= 0;		/* Flugzeit Minuten */
volatile int			F_SEC 		= 0;		/* Flugzeit Sekunden*/
volatile char			EMPF_WERT	= 2;	/* Vorbesetzen mit 2			*/
volatile char			EMPF_WERT_AENDERUNG = 0;
volatile char			SENDER 		= 0;	/* Senderbetrieb 1, kein Sender 0 */
volatile int 	Hoehe, Alt_Hoehe, Delta_Hoehe,Int_Delta_Hoehe, M_Delta_Hoehe;
volatile char	Int_Delta_Hoehe_S = 0;

volatile unsigned int	K_GRAD;
volatile unsigned int	K_DISP;
volatile unsigned char 	kompass_ok = 0;



void init_io(void)
{

#ifdef HW_V_01
	
	DDRC = 0xFF;						/* PortD auf Ausgang 		*/
	DDRD = (1<<PIN3)|(1<<PIN7);	
	sbi(PORTD,7);						/* PullUp Reset				*/
	DDRB = (1<<PIN1)|(1<<PIN5)|(1<<PIN7);
//	sbi(PORTB,6);						/* pullup aktibieren 		*/
	sbi(PORTB,1);						/* |cs auf high 			*/ 

#endif

#ifdef HW_V_02

	DDRD = (1<<PIN4);				/* Sound als Ausgang  Entfllt erstaml */
	DDRC = 0xFF;						/* PortD auf Ausgang */
	DDRA = (1<<PIN1)|(1<<PIN3)|(1<<PIN5) |(1<<PIN2);
	Set_Cs;
	No_Reset_Max;

#endif

}


int main(void)
{
	char z;
	
		
	init_io();				/* Ein.und Ausgnge definieren 			*/
	init_timer0();			/* Timer definieren						*/
	init_uarts();			/* com0 und com1 definieren				*/

	sei();					/* global alle Interrupts freigeben		*/

	GRUEN_ON;				/* Grne Statusled an					*/
	
	set_init_osd();			/* OSD initialisieren					*/
	init_hoehe();
	init_f_time();
	write_lipo_initial();	/* Lipoanzeige vorbesetzen  */

//	write_pixel_data();		/* Schreibt Zeichensatz ein Zeichen 	*/
	write_horizontal();		/* Horizontale Linie fr kh */
	




/********************************************************************/
/* Program Hauptschleife											*/

	while(1)
	{
		if ( MSEC100 == 1)				/* do all 100msec						*/
		{
			MSEC100 = 0;
			z++;
//			if ( z >1)
//			{
			send_FC_C();
			z=0;
//			}
			if(SENDER == 0)
				vario_int();
			else
				if(EMPF_WERT > 1)
					vario_int();

			rote_led();					/* wenn blink_rot ==1 blinken			*/
			gruene_led();				/* dito grn							*/
	
		}

		if(kompass_ok == 1)				/* Kompassdaten stehen an				*/
		{
			if(SENDER == 0)				/* Kein Senderbetrieb					*/
				update_kompass();
			else
			{
				if(EMPF_WERT > 1)
				{
					update_kompass();

				}
			}


			kompass_ok = 0;
		}

		if(ds_komplett_0 == 1)			/* Datensatz ist da und kann verarbeitet werden */
		{
			GRUEN_ON1;

			Daten_satz_0_verarbeiten();	/* Datensatz FC verarbeiten					*/
		
			if(SENDER == 0)
			{
				update_roll_line();
				update_nick_line ();

				update_lipo_wert();
//				write_steig_fall();
				update_hoehe();
			}
			else
			{
				if(EMPF_WERT > 1)	/* OSD ohne HUD, OSD mit HUD */
				{
					update_lipo_wert();
//					write_steig_fall();
					update_hoehe();

				}
				
				if(EMPF_WERT > 2)	/* OSD mit HUD */
				{
					update_roll_line();
					update_nick_line ();
				}
			}			
					
			GRUEN_OFF1;
		}
		if ( MSEC1000 == 1 )			/* do all 1000msec = 1 sec 					*/
		{
			MSEC1000 = 0;
			if( SENDER == 0 )
				write_horizontal();
			else
				if(EMPF_WERT > 2 )
					write_horizontal();	
					
							
//			bbb = receive_byte(0xa0);
//			uart_send_binary (bbb);
			if( F_SEC++ == 59 )
			{
				F_MIN++;
				F_SEC = 0;
			}
			update_f_time();			
	
		}
		if ( MSEC500 == 1 )			/* do all 500msec = 1 sec 					*/
		{
			MSEC500 = 0;
			send_debug_data();

			if(SENDER == 1 )		/* Bedienung ber Sender */
			{
				if(EMPF_WERT_AENDERUNG == 1 )  /* Es ist ein anderer Modus gewhlt */
				{
					EMPF_WERT_AENDERUNG = 0;
									
					switch (EMPF_WERT)
					{
						case 0:
								OSD_OFF();
								break;
						case 1:
								OSD_ON();
								show_logo();
								break;	
						case 2: 
								OSD_ON();
								send_spi_2_byte(DMM,4);  /* Lsche Bildschirm */
								init_hoehe();
								init_f_time();
								write_lipo_initial();	/* Lipoanzeige vorbesetzen  */
								break;
						case 3:

								OSD_ON();
								send_spi_2_byte(DMM,4);  /* Lsche Bildschirm */
								init_hoehe();
								init_f_time();
								write_lipo_initial();	/* Lipoanzeige vorbesetzen  */
								write_horizontal();		/* Horizontale Linie fr kh */
								break;	
					}			
				}
			}								
		}
	}

}


