/****************************************************************/
/*  main.h 														*/
/*																*/
/*																*/
/*																*/
/*	written by Wolfgang Wierczeyko	Mrz 2008					*/
/*																*/
/*																*/
/*																*/
/*																*/
/****************************************************************/


//#define HW_V_01 1
#define HW_V_02 1

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <math.h>


#include "timer0.h"


#include "osd.h"
#include "Zeichensatz.h"
#include "uart.h"
#include "setuposd.h"
#include "Datenhandling.h"
#include "ledctrl.h"
#include "empf.h"
#include "vario.h"


#define F_OSC 16000000       			/* Taktfrequenz 16 MHz interner Takt 	*/
#define USART_BAUD  (F_OSC/38400/8)-1 	/* 54,700kBaud mit U2X					*/ 
	
/* Definition der Commands MAX 7456												*/
#define VM0   	0
#define VM1   	1
#define HOS   	2
#define VOS   	3
#define DMM   	4
#define DMAH  	5
#define DMAL  	6
#define DMDI  	7
#define CMM		0x08
#define CMAH	0x09	
#define CMAL	0x0A
#define CMDI	0x0b
#define OSDBL	0x6C
/* Vertrglichkeit mit neueren CompilerVersionen */

#define sbi(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define cbi(ADDRESS,BIT) ((ADDRESS) &= ~(1<<(BIT)))
#define outp(VAL,ADRESS) ((ADRESS) = (VAL))

#define RXB_LEN_0  150
#define	ROT	PD3

/**********************************************************************	*/
/* Makros fr Version 0.1												*/

#ifdef HW_V_01

#define TOGGLE_AUDIO PORTD ^= 0x08;
/* Makros fr die Leds													*/
#define	ROT_ON		sbi(PORTC,1) 	/* Macht die Rote StatusLed 0 an 	*/
#define	ROT_OFF		cbi(PORTC,1)	/* Aus und so weiter				*/
#define ROT_BLINK   PORTC ^= 0x02;
#define GRUEN_ON  	sbi(PORTC,0)
#define GRUEN_OFF  	cbi(PORTC,0)
#define GRUEN_BLINK PORTC ^= 0x01;

#define	ROT_ON1		sbi(PORTC,3) 
#define	ROT_OFF1	cbi(PORTC,3)
#define ROT_BLINK1  PORTC ^= 0x08;
#define GRUEN_ON1  	sbi(PORTC,2)
#define GRUEN_OFF1 	cbi(PORTC,2)

/* Makros fr SPI Datenaustausch */
#define Reset_Cs	cbi(PORTB,1)
#define Reset_Mosi	cbi(PORTB,5)
#define Reset_Sclk	cbi(PORTB,7)
#define Set_Cs		sbi(PORTB,1)
#define Set_Mosi	sbi(PORTB,5)
#define Set_Sclk	sbi(PORTB,7)
#define Reset_Max	cbi(PORTD,7)
#define No_Reset_Max sbi(PORTD,7)

#endif

/**********************************************************************	*/
/* Makros fr Version 0.2												*/
#ifdef HW_V_02

#define TOGGLE_AUDIO PORTD ^= 0x08;
/* Makros fr die Leds													*/
#define	ROT_ON		sbi(PORTC,1) 	/* Macht die Rote StatusLed 0 an 	*/
#define	ROT_OFF		cbi(PORTC,1)	/* Aus und so weiter				*/
#define ROT_BLINK   PORTC ^= 0x02;
#define GRUEN_ON  	sbi(PORTC,0)
#define GRUEN_OFF  	cbi(PORTC,0)
#define GRUEN_BLINK PORTC ^= 0x01;

#define	ROT_ON1		sbi(PORTC,3) 
#define	ROT_OFF1	cbi(PORTC,3)
#define ROT_BLINK1  PORTC ^= 0x08;
#define GRUEN_ON1  	sbi(PORTC,2)
#define GRUEN_OFF1 	cbi(PORTC,2)

/* Makros fr SPI Datenaustausch */
#define Reset_Cs	cbi(PORTA,1)
#define Reset_Mosi	cbi(PORTA,2)
#define Reset_Sclk	cbi(PORTA,3)
#define Set_Cs		sbi(PORTA,1)
#define Set_Mosi	sbi(PORTA,2)
#define Set_Sclk	sbi(PORTA,3)
#define Reset_Max	cbi(PORTA,5)
#define No_Reset_Max sbi(PORTA,5)

#endif



extern volatile uint8_t		MSEC1000;
extern volatile uint8_t		MSEC100;
extern volatile uint8_t		MSEC500;
extern volatile uint8_t		MSEC10;
extern volatile uint8_t		Tackt;

extern volatile unsigned char 	RX_BUFF_0[RXB_LEN_0];
extern volatile unsigned char 	rx_poi_0;
extern volatile unsigned char 	ds_komplett_0;
extern volatile unsigned char 	r_on;
extern volatile unsigned char 	r_blink; 
extern volatile unsigned char	g_on;
extern volatile unsigned char 	g_blink;
extern volatile int 			old_volt;

extern volatile int			F_MIN ;		/* Flugzeit Minuten */
extern volatile int			F_SEC ;		/* Flugzeit Sekunden*/
extern volatile char		EMPF_WERT;
extern volatile char		EMPF_WERT_AENDERUNG;
extern volatile int 	Hoehe, Alt_Hoehe, Delta_Hoehe,Int_Delta_Hoehe, M_Delta_Hoehe;
extern volatile char	Int_Delta_Hoehe_S;

extern volatile unsigned int	K_GRAD;
extern volatile unsigned int	K_DISP;

extern volatile unsigned char 	kompass_ok;
