/****************************************************************/
/*  timer0.c													*/
/*																*/
/*	Taktgeber ber Timer0										*/
/*																*/
/*	written by Wolfgang Weirczeyko	Mrz 2008					*/
/*																*/
/*																*/
/*																*/
/*																*/
/****************************************************************/

#include "main.h"


volatile unsigned char	r_flash = 0;
volatile uint8_t 		t1000;
volatile uint8_t 		t100;
uint8_t 				gr_on = 0 ;

 
void init_timer0(void)
{
/** Timer 0 ***/
	TCCR0 	= (1 << CS01);  /* Prescaler auf 8 hier eventuell noch anpassen */
	TCCR1B 	= (1 << ICES1)|(1 << CS11); /* Trigger ICS1 Pin auf steigende Flanke clk/8 */							/* Startwert timer auch noch definieren			*/
	TIMSK 	= (1 << TOIE0)|(1 << TICIE1)|(1<<OCIE2);	/* Overflow Int zulassen */
	TCCR2	= (1 <<	CS22) |(1 <<  CS21) ;
	OCR2 	= 240;
	TCCR3B 	= (1 << ICES3)|(1 << CS11)|(1 << CS10) ; /* Trigger ICS1 Pin auf steigende Flanke clk/8 */
	ETIMSK  = (1<<TICIE3);
}

/****************************************************************************/
SIGNAL( SIG_OVERFLOW0) /* Timer0 Mdchen fr alles mgliche */
{
	
	/* Takterzeugung 10 msec 100 msec und 1 sec. */
		
		Tackt++;
		if(Tackt == 72) /* Anpassung an Taktfrequenz ATMega */	
		{ 	
			MSEC10 = 1;
			Tackt=0;
			
		

			if ( ++t1000 == 100 )	/* 1000msec flag setzen */
			{
				t1000 = 0;
				MSEC1000 = 1;
				MSEC500  = 1;		/* 500 msec flag setzen */
			} 

			if ( t1000 == 50)		/* 500 msec flag setzen */
				MSEC500 =1;
		
			if ( ++t100 == 10 )		/* 100 msec flag setzen */
			{
				t100 = 0;
				MSEC100 = 1;
			} 
		 } 	/* Taktverhltniss anhaeherd richtig */
	
}
